unit Usbfun;

interface
uses  SysUtils, WinTypes, WinProcs, Messages, Classes, usbdefs,dpmi1
,dialogs;

function iferr(er:word):string; export;
implementation

function iferr(er:word):string; begin
if(er=I14RErrNone)then begin result:=('No Error');end else
if(er=I14RErrResources)then begin result:=('Insufficient Resources/Memory');end else
if(er=I14RErrHostHardware)then begin result:=('Unknown/Hardware Problem with Host');end else
if(er=I14RErrReqTypeNoSupt)then begin result:=('Request Type recognized, but not Supported');end else
if(er=I14RErrRequestType)then begin result:=('Invalid Request Type');end else
if(er=I14RErrFlags)then begin result:=('Invalid Flags');end else
if(er=I14RErrHostIndex)then begin result:=('Invalid Host Index');end else
if(er=I14RErrDeviceAddress)then begin result:=('Invalid Device Address');end else
if(er=I14RErrHubAddress)then begin result:=('Invalid Hub Address');end else
if(er=I14RErrEndPoint)then begin result:=('Invalid EndPoint');end else
if(er=I14RErrHubPort)then begin result:=('Invalid Hub Port');end else
if(er=I14RErrAltIntf)then begin result:=('Invalid Alternate Interface');end else
if(er=I14RErrConfigValue)then begin result:=('Invalid Configuration Value');end else
if(er=I14RErrCloseID)then begin result:=('Invalid Closure ID');end else
if(er=I14RErrDataX)then begin result:=('Invalid DataX Value');end else
if(er=I14RErrInterfaceNum)then begin result:=('Invalid Interface Number');end else
if(er=I14RErrSearchIndex)then begin result:=('Invalid Search Index');end else
if(er=I14RErrVendorProdID)then begin result:=('Invalid Vendor ID');end else
if(er=I14RErrDvcIntf)then begin result:=('Invalid Device/Interface value');end else
if(er=I14RErrRequestHandle)then begin result:=('Invalid Request Handle');end else
if(er=I14RErrPeriodicity)then begin result:=('Invalid Periodicity');end else
if(er=I14RErrBeepFrequency)then begin result:=('Invalid Beep Frequency');end else
if(er=I14RErrTimeOut)then begin result:=('Invalid Timeout');end else
if(er=I14RErrDataAddress)then begin result:=('Invalid Data Address');end else
if(er=I14RErrDataSize)then begin result:=('Invalid Data Size (Low Speed <= 8)');end else
if(er=I14RErrCallBackAddr)then begin result:=('Invalid Call Back Address');end else
if(er=I14RErrLCRtnCode)then begin result:=('Invalid Large Call result Code');end else
if(er=I14RErrUserPktID)then begin result:=('Invalid User Pkt ID (matches on unregistry');end else
if(er=I14RErrSetupReqData)then begin result:=('Invalid Setup Request Data');end else
if(er=I14RErrFrameTiming)then begin result:=('Invalid Frame Timing');end else
if(er=I14RErrFrameIndex)then begin result:=('Invalid Frame Index');end else
if(er=I14RErrIsochArray)then begin result:=('Invalid Entry in Isoch Array Data');end else
if(er=I14RErrHostHalted)then begin result:=('Host is Halted/Suspended');end else
if(er=I14RErrIntfNotFound)then begin result:=('Interface not found (on FindIntf/RegIntf)');end else
if(er=I14RErrIntfInConfig)then begin result:=('Interface already beging Configured');end else
if(er=I14RErrIntfAlreadyReg)then begin result:=('Interface already Registered');end else
if(er=I14RErrHostCallInUse)then begin result:=('Host Run/Stop/etc. already running');end else
if(er=I14RErrNoPortPower)then begin result:=('Per-Port-Power not Supported by Hub');end else
if(er=I14RErrAlreadyBeeping)then begin result:=('Another Beep Request is already being handled');end else
if(er=I14RErrDebugMode)then begin result:=('Tried to Single Step with No Debug Mode');end else
if(er=I14RErrTimingOwned)then begin result:=('Problem with Frame Timing Owner');end else
if(er=I14RErrTimingLimit)then begin result:=('Frame Timing is already at the Limit');end else
if(er=I14RErrTmgChgInProg)then begin result:=('Timing Change already in progress');end else
end;

function  whatclass(intf:word):string; begin
if(intf=RptTagUsagePage)then begin result:=('Usage Page');end else
  if(intf=RptGlbUPGenericDeskTop)then begin result:=('$01{Generic Desktop');end else
    if(intf=RptGDPointer)then begin result:=('$01{Pointing Device');end else
    if(intf=RptGDMouse)then begin result:=('$02{Mouse');end else
     {03h)then begin result:=('$ Reserved');end else}
    if(intf=RptGDJoystick)then begin result:=('$04{Joystick');end else
    if(intf=RptGDGamePad)then begin result:=('$05{GamePad');end else
    if(intf=RptGDKeyboard)then begin result:=('$06{Keyboard');end else
    if(intf=RptGDKeyPad)then begin result:=('$07{KeyPad');end else
    if(intf=RptGDMultiAxisCtl)then begin result:=('$08{Multi-Axis Controller');end else
       {09h - 2Fh)then begin result:=('$ Reserved');end else}
    if(intf=RptGDXAxis)then begin result:=('$30{X-axis');end else
    if(intf=RptGDYAxis)then begin result:=('$31{Y-axis');end else
    if(intf=RptGDZAxis)then begin result:=('$32{Z-axis');end else
    if(intf=RptGDRotateX)then begin result:=('$33{Rotation around X-axis');end else
    if(intf=RptGDRotateY)then begin result:=('$34{Rotation around Y-axis');end else
    if(intf=RptGDRotateZ)then begin result:=('$35{Rotation around Z-axis');end else
    if(intf=RptGDSlider)then begin result:=('$36{Slider');end else
    if(intf=RptGDDial)then begin result:=('$37{Dial');end else
    if(intf=RptGDWheel)then begin result:=('$38{Wheel');end else
    if(intf=RptGDHatSwitch)then begin result:=('$39{Hat-Switch');end else
    if(intf=RptGDCountedBuff)then begin result:=('$3A{Counted Buffer');end else
    if(intf=RptGDByteCount)then begin result:=('$3B{Byte Count');end else
    if(intf=RptGDMotionWakeup)then begin result:=('$3C{Wakeup on Motion');end else
    if(intf=RptGDStart)then begin result:=('$3D{Start');end else
    if(intf=RptGDSelect)then begin result:=('$3E{Select');end else
      {3Fh Reserved');end else}
    if(intf=RptGDVectorX)then begin result:=('$40{X-Axis Vector');end else
    if(intf=RptGDVectorY)then begin result:=('$41{Y-Axis Vector');end else
    if(intf=RptGDVectorZ)then begin result:=('$42{Z-Axis Vector');end else
    if(intf=RptGDVectorBRX)then begin result:=('$43{X-Axis Vector, Relative to Body');end else
    if(intf=RptGDVectorBRY)then begin result:=('$44{Y-Axis Vector, Relative to Body');end else
    if(intf=RptGDVectorBRZ)then begin result:=('$45{Z-Axis Vector, Relative to Body');end else
    if(intf=RptGDVectorNoD)then begin result:=('$46{Non-Directional Tempurature,etc');end else
      {47h)then begin result:=('$ ??');end else}
    if(intf=RptGDResMult)then begin result:=('$48{Resolution Multiplier');end else
      {49h-7Fh)then begin result:=('$ Reserved');end else}
    if(intf=RptGDSysCtl)then begin result:=('$80{System Control');end else
    if(intf=RptGDSysPowerDown)then begin result:=('$81{System Power Down');end else
    if(intf=RptGDSysSleep)then begin result:=('$82{System Sleep');end else
    if(intf=RptGDSysWakeUp)then begin result:=('$83{System Wake Up');end else
    if(intf=RptGDSysMenuContext)then begin result:=('$84{System Menu Context');end else
    if(intf=RptGDSysMenuMain)then begin result:=('$85{System Menu Main');end else
    if(intf=RptGDSysMenuApp)then begin result:=('$86{System Menu Application');end else
    if(intf=RptGDSysMenuHelp)then begin result:=('$87{System Menu Help');end else
    if(intf=RptGDSysMenuExit)then begin result:=('$88{System Menu Exit');end else
    if(intf=RptGDSysMenuSelect)then begin result:=('$89{System Menu Select');end else
    if(intf=RptGDSysMenuRight)then begin result:=('$8A{System Menu Right');end else
    if(intf=RptGDSysMenuLeft)then begin result:=('$8B{System Menu Left');end else
    if(intf=RptGDSysMenuUp)then begin result:=('$8C{System Menu Up');end else
    if(intf=RptGDSysMenuDown)then begin result:=('$8D{System Menu Down');end else
    if(intf=RptGDSysColdStart)then begin result:=('$8E{System Cold Restart');end else
    if(intf=RptGDSysWarmStart)then begin result:=('$8F{System Warm Restart');end else
    if(intf=RptGDDPadUp)then begin result:=('$90{D-Pad Up');end else
    if(intf=RptGDDPadDown)then begin result:=('$91{D-Pad Down');end else
    if(intf=RptGDDPadRight)then begin result:=('$92{D-Pad Right');end else
    if(intf=RptGDDPadLeft)then begin result:=('$93{D-Pad Left');end else
      {94h - 9Fh)then begin result:=('$ Reserved');end else}
    if(intf=RptGDSysDock)then begin result:=('$A0{System Dock');end else
    if(intf=RptGDSysUndock)then begin result:=('$A1{System Undock');end else
    if(intf=RptGDSysSetup)then begin result:=('$A2{System Setup');end else
    if(intf=RptGDSysBreak)then begin result:=('$A3{System Break');end else
    if(intf=RptGDSysDbgBrk)then begin result:=('$A4{System Debugger Break');end else
    if(intf=RptGDSysAppBrk)then begin result:=('$A5{Application Break');end else
    if(intf=RptGDSysAppDbgBrk)then begin result:=('$A6{Application Debugger Break');end else
    if(intf=RptGDSysMute)then begin result:=('$A7{System Speaker Mute');end else
    if(intf=RptGDSysHibernate)then begin result:=('$A8{System Hibernate');end else
      {A9h - AFh)then begin result:=('$ Reserved');end else}
    if(intf=RptGDSysDispInvt)then begin result:=('$B0{System Display Invert');end else
    if(intf=RptGDSysDispInt)then begin result:=('$B1{System Display Internal');end else
    if(intf=RptGDSysDispExt)then begin result:=('$B2{System Display External');end else
    if(intf=RptGDSysDispBoth)then begin result:=('$B3{System Display Both');end else
    if(intf=RptGDSysDispDual)then begin result:=('$B4{System Display Dual');end else
    if(intf=RptGDSysDispTgl)then begin result:=('$B5{System Display Toggle ');end else
    if(intf=RptGDSysDispSwap)then begin result:=('$B6{System Display Swap ');end else
    if(intf=RptGDSysDispAuto)then begin result:=('$B7{System Display LCD Autoscale');end else
      {B8h - FFFFh)then begin result:=('$ Reserved');end else}

  if(intf=RptGlbUPSimulationCtl)then begin result:=('$02{Simulation Controls');end else
    if(intf=RptSimFlightSim)then begin result:=('$01{Flight Simulation Device');end else
    if(intf=RptSimAutoSim)then begin result:=('$02{Automobile Simulation Device');end else
    if(intf=RptSimTankSim)then begin result:=('$03{Tank Simulation Device');end else
    if(intf=RptSimSpaceShipSim)then begin result:=('$04{Spaceship Simulation Device');end else
    if(intf=RptSimSubmarineSim)then begin result:=('$05{Submarine Simulation Device');end else
    if(intf=RptSimSailingSim)then begin result:=('$06{Sailing Simulation Device');end else
    if(intf=RptSimMotorcycleSim)then begin result:=('$07{Motorcycle Simulation Device');end else
    if(intf=RptSimSportsSim)then begin result:=('$08{Sports Simulation Device');end else
    if(intf=RptSimAirplaneSim)then begin result:=('$09{Airplane Simulation Device');end else
    if(intf=RptSimHelicopterSim)then begin result:=('$0A{Helicopter Simulation Device');end else
    if(intf=RptSimMagicCarpetSim)then begin result:=('$0B{Magic Carpet Simulation Device');end else
    if(intf=RptSimBicycleSim)then begin result:=('$0C{Bicycle Simulation Device');end else
      {0Dh - 1Fh)then begin result:=('$ Reserved');end else}
    if(intf=RptSimFlightCtlStick)then begin result:=('$20{Flight Control Stick');end else
    if(intf=RptSimFlightStick)then begin result:=('$21{Flight Stick');end else
    if(intf=RptSimCyclicCtl)then begin result:=('$22{Cyclic Control');end else
    if(intf=RptSimCyclicTrim)then begin result:=('$23{Cyclic Trim');end else
    if(intf=RptSimFlightYoke)then begin result:=('$24{Flight Yoke');end else
    if(intf=RptSimTrackCtl)then begin result:=('$25{Track Control');end else
      {26h - AFh)then begin result:=('$ Reserved');end else}
    if(intf=RptSimAileron)then begin result:=('$B0{Aileron');end else
    if(intf=RptSimAileronTrim)then begin result:=('$B1{Aileron Trim');end else
    if(intf=RptSimAntiTorqueCtl)then begin result:=('$B2{Anti-Torque Control');end else
    if(intf=RptSimAutoPilot)then begin result:=('$B3{Autopilot Enable');end else
    if(intf=RptSimChaffRelease)then begin result:=('$B4{Chaff Release');end else
    if(intf=RptSimCollectiveCtl)then begin result:=('$B5{Collective Control');end else
    if(intf=RptSimDiveBrake)then begin result:=('$B6{Dive Brake');end else
    if(intf=RptSimElecCtrMsrs)then begin result:=('$B7{Electronic Countermeasures');end else
    if(intf=RptSimElevator)then begin result:=('$B8{Elevator');end else
    if(intf=RptSimElevatorTrim)then begin result:=('$B9{Elevator Trim');end else
    if(intf=RptSimRudder)then begin result:=('$BA{Rudder');end else
    if(intf=RptSimThrottle)then begin result:=('$BB{Throttle');end else
    if(intf=RptSimFlightComm)then begin result:=('$BC{Flight Communications');end else
    if(intf=RptSimFlareRelease)then begin result:=('$BD{Flare Release');end else
    if(intf=RptSimLandingGear)then begin result:=('$BE{Landing Gear');end else
    if(intf=RptSimToeBrake)then begin result:=('$BF{Toe Brake');end else
    if(intf=RptSimTrigger)then begin result:=('$C0{Trigger');end else
    if(intf=RptSimWeaponsArm)then begin result:=('$C1{Weapons Arm');end else
    if(intf=RptSimWeaponsSelect)then begin result:=('$C2{Weapons Select');end else
    if(intf=RptSimWingFlaps)then begin result:=('$C3{Wing Flaps');end else
    if(intf=RptSimAccelerator)then begin result:=('$C4{Accelerator');end else
    if(intf=RptSimBrake)then begin result:=('$C5{Brake');end else
    if(intf=RptSimClutch)then begin result:=('$C6{Clutch');end else
    if(intf=RptSimShifter)then begin result:=('$C7{Shifter');end else
    if(intf=RptSimSteering)then begin result:=('$C8{Steering');end else
    if(intf=RptSimTurretDir)then begin result:=('$C9{Turret Direction');end else
    if(intf=RptSimBarrelElev)then begin result:=('$CA{Barrel Elevation');end else
    if(intf=RptSimDivePlane)then begin result:=('$CB{Dive Plane');end else
    if(intf=RptSimBallast)then begin result:=('$CC{Ballast');end else
    if(intf=RptSimBicycleCrank)then begin result:=('$CD{Bicycle Crank');end else
    if(intf=RptSimHandlebars)then begin result:=('$CE{Handle Bars');end else
    if(intf=RptSimFrontBrake)then begin result:=('$CF{Front Brake');end else
    if(intf=RptSimRearBrake)then begin result:=('$D0{Rear Brake');end else
      {D1h - FFFFh)then begin result:=('$ Reserved');end else}

  if(intf=RptGlbUPVRCtl)then begin result:=('$03{Virtual Reality? Controls');end else
  if(intf=RptGlbUPSportCtl)then begin result:=('$04{Sport Controls');end else
  if(intf=RptGlbUPGameCtl)then begin result:=('$05{Game Controls');end else
    if(intf=RptGame3DCtl)then begin result:=('$01{3D game Controller');end else
    if(intf=RptGamePinball)then begin result:=('$02{Pinball Device');end else
    if(intf=RptGameGun)then begin result:=('$03{Gun Device');end else
      {04h - 1Fh)then begin result:=('$ Reserved');end else}
    if(intf=RptGamePOV)then begin result:=('$20{Point-of-View');end else
    if(intf=RptGameTurn)then begin result:=('$21{Turn Right/Left');end else
    if(intf=RptGamePitch)then begin result:=('$22{Pitch Right/Left');end else
    if(intf=RptGameRoll)then begin result:=('$23{Roll Forward/Backward');end else
    if(intf=RptGameMoveX)then begin result:=('$24{Move Right/Left');end else
    if(intf=RptGameMoveY)then begin result:=('$25{Move Forward/Backward');end else
    if(intf=RptGameMoveZ)then begin result:=('$26{Move Up/Down');end else
    if(intf=RptGameLeanX)then begin result:=('$27{Lean Right/Left');end else
    if(intf=RptGameLeanY)then begin result:=('$28{Lean Forward/Backward');end else
    if(intf=RptGamePOVHeight)then begin result:=('$29{Height of Point-of-View');end else
    if(intf=RptGameFlipper)then begin result:=('$2A{Flipper');end else
    if(intf=RptGameFlipper2)then begin result:=('$2B{Secondary Flipper');end else
    if(intf=RptGameBump)then begin result:=('$2C{Bump');end else
    if(intf=RptGameNewgame)then begin result:=('$2D{New Game');end else
    if(intf=RptGameShootball)then begin result:=('$2E{Shoot ball');end else
    if(intf=RptGamePlayer)then begin result:=('$2F{Player');end else
    if(intf=RptGameGunBolt)then begin result:=('$30{Gun Bolt');end else
    if(intf=RptGameGunClip)then begin result:=('$31{Gun Clip');end else
    if(intf=RptGameGunSelector)then begin result:=('$32{Gun Selector');end else
    if(intf=RptGameGunSingleShot)then begin result:=('$33{Gun Single Shot');end else
    if(intf=RptGameGunBurst)then begin result:=('$34{Gun Burst Shot');end else
    if(intf=RptGameGunAutomatic)then begin result:=('$35{Gun Automatic Shot');end else
    if(intf=RptGameGunSafety)then begin result:=('$36{Gun Safety');end else
    if(intf=RptGamePadFireJump)then begin result:=('$37{GamePad Fire/Jump');end else
      {38h)then begin result:=('$ ???');end else}
    if(intf=RptGamePadTrigger)then begin result:=('$39{GamePad Trigger');end;

end;


end.
